/*	
	OrariFS 0.4
	
	Author: Paolo Grifantini 2008-01-13
	Contact: pagri@tele2.it
	
	This work is licensed under a Creative Commons License
	http://creativecommons.org/licenses/by-nc-sa/2.0/
	
	Attribution-NonCommercial-ShareAlike 2.0
	
	You are free:
	* to copy, distribute and display the work
	* to make derivative works
	
	Under the following conditions:
	* Attribution. You must give the original author credit.
	* Noncommercial. You may not use this work for commercial purposes.
	* Share Alike. If you alter, transform, or build upon this work, you may 
		distribute the resulting work only under a license identical to this one.
	
	* For any reuse or distribution, you must make clear to others the license terms of this work.
	* Any of these conditions can be waived if you get permission from the copyright holder.
	
*/

var newShow = { show : function(element) { $(element).style.display = 'block'; return element; } }
Element.addMethods(newShow);

var current_version = "0.4";
var there_is_a_new_version = false;

window.onload = init;

function init(){
	localize_strings();
	
	CreateButton('button', { text: getLocalizedString('cerca'), onclick: 'getOrariNazionali', rightImageWidth: 5, leftImageWidth: 5 });
	
	setTimeout("version_check();", 20*1000);
}

function localize_strings()
{
	document.getElementById("MappaSelect0").innerHTML = getLocalizedString('linguetta_nazionali');
	document.getElementById("MappaSelect0").alt = getLocalizedString('title_tooltip_on');
	document.getElementById("MappaSelect0").title = getLocalizedString('title_tooltip_on');
	
	document.getElementById("staz_partenza").innerHTML = getLocalizedString('label_partenza');
	document.getElementById("staz_arrivo").innerHTML = getLocalizedString('label_arrivo');
	document.getElementById("data_partenza").innerHTML = getLocalizedString('label_data');
	document.getElementById("ora_partenza").innerHTML = getLocalizedString('label_ora');
}

var nazionaliVis='';
var internazionaliVis='';

function zeroFill(q,z){
	q=String(q);
	while(q.length<z)q="0"+q;
	return q;
}

function resize_on_finish(obj){
  window.resizeTo(239,40);
}

function showDiv(divName){
	// prima nascondo gli altri
	
	if (divName=='nazionali'){
	
		if (nazionaliVis){
			nazionaliVis='';
			document.getElementById("MappaSelect0").style.color = 'darkgreen';
			
			//document.getElementById('riNazionali').style.display = 'none';
			Effect.BlindUp('riNazionali',{ duration: 0.2, afterFinish: resize_on_finish});
			
			document.getElementById("MappaSelect0").alt = getLocalizedString('title_tooltip_on');
			document.getElementById("MappaSelect0").title = getLocalizedString('title_tooltip_on');
		}
		else {
			nazionaliVis=1;
			document.getElementById("MappaSelect0").style.color = 'black';
			
			document.getElementById("MappaSelect0").alt = getLocalizedString('title_tooltip_off');
			document.getElementById("MappaSelect0").title = getLocalizedString('title_tooltip_off');
			
			//prima nascondi le altre
			internazionaliVis='';
			document.getElementById("MappaSelect1").style.color = 'darkgreen';
			document.getElementById('riInternazionali').style.display = 'none';
			
			
			//poi prepara i campi
			
			document.getElementById('stazin').value = '';
			document.getElementById('stazout').value = '';
			
			now=new Date();
			d=zeroFill(now.getDate(),2);
			m=zeroFill(now.getMonth()+1,2);
			Y=now.getFullYear();
			H=zeroFill(now.getHours(),2);
			min=zeroFill(now.getMinutes(),2);
			
			document.getElementById("datag").selectedIndex = d-1; //sottraggo 1 perch nella posizione 0 c' il giorno 1
			document.getElementById("datam").selectedIndex = m-1;
			
			document.getElementById("dataa").options[0].text = Y;
			document.getElementById("dataa").options[1].text = Y+1;
			document.getElementById("dataa").options[2].text = Y+2;
			document.getElementById("dataa").options[0].value = Y;
			document.getElementById("dataa").options[1].value = Y+1;
			document.getElementById("dataa").options[2].value = Y+2;
			
			document.getElementById("timsh").selectedIndex = H;
			document.getElementById("timsm").selectedIndex = min;
			
			
			document.getElementById('staz_partenza').style.color = 'black';
			document.getElementById('staz_arrivo').style.color = 'black';
			
			//poi mostra
			window.resizeTo(239,300);
			Effect.BlindDown('riNazionali',{ duration: 0.2 });
			//document.getElementById('riNazionali').style.display = 'block';
		}
	}
	else{
		if (internazionaliVis){
			internazionaliVis='';
			document.getElementById("MappaSelect1").style.color = 'darkgreen';
			
			document.getElementById('riInternazionali').style.display = 'none';
			
			window.resizeTo(239,40);
		}
		else {
			internazionaliVis=1;
			document.getElementById("MappaSelect1").style.color = 'black';
			
			//prima nascondi le altre
			nazionaliVis='';
			document.getElementById("MappaSelect0").style.color = 'darkgreen';
			document.getElementById('riNazionali').style.visibility = 'hidden';
			
			//poi mostra
			window.resizeTo(239,300);
			document.getElementById('riInternazionali').style.display = 'block';
		}
	}
					
}


function getOrariNazionali(){
	toReturn = '';
	
	stazPartenza=document.getElementById('stazin').value;
	stazArrivo=document.getElementById('stazout').value;
	stazPartenzaSenzaSpazi = stazPartenza.replace(/\s+/g," ");
	stazArrivoSenzaSpazi = stazArrivo.replace(/\s+/g," ");
	
	stazPartenza = stazPartenza.replace(/[\s]+/g,'+');
	stazArrivo = stazArrivo.replace(/[\s]+/g,'+');
		
	if ( (stazPartenzaSenzaSpazi == '') || (stazPartenzaSenzaSpazi == ' ') ){
		document.getElementById('staz_partenza').style.color = 'red';
				
		toReturn = 1;
	}
	else {document.getElementById('staz_partenza').style.color = 'black';}
	
	if ( (stazArrivoSenzaSpazi == '') || (stazArrivoSenzaSpazi == ' ') ){
		document.getElementById('staz_arrivo').style.color = 'red';
				
		toReturn = 1;
	}
	else {document.getElementById('staz_arrivo').style.color = 'black';}
	
	if (toReturn) {return;}
	
	
	giorno = document.getElementById("datag");
	sel = giorno.selectedIndex;
	datag = giorno.options[sel].value;
	
	mese = document.getElementById("datam");
	sel = mese.selectedIndex;
	datam = mese.options[sel].value;
	
	anno = document.getElementById("dataa");
	sel = anno.selectedIndex;
	dataa = anno.options[sel].value;
	
	ora = document.getElementById("timsh");
	sel = ora.selectedIndex;
	timsh = ora.options[sel].value;
	
	min = document.getElementById("timsm");
	sel = min.selectedIndex;
	timsm = min.options[sel].value;
									
	widget.openURL("http://orario.trenitalia.com/b2c/nppPriceTravelSolutions.do?stazin="+stazPartenza+"&stazout="+stazArrivo+"&datag="+datag+"&datam="+datam+"&dataa="+dataa+"&timsh="+timsh+"&timsm="+timsm+"&lang=it&nreq=5&channel=tcom");
		
}

function swapMouseDown(event)
{

}

function swapMouseUp(event)
{
    switchText();
}

function switchText(){
	swap_var = document.getElementById('stazin').value;
	document.getElementById("stazin").value = document.getElementById("stazout").value;
	document.getElementById("stazout").value = swap_var;
}

//************ version check **************************************

function goToDownloadPage()
{
	// vai al sito
	widget.openURL("http://www.palple.net/widgets/orarifs/OrariFS.zip");
}

var version_req_stop_timeout = false;
var version_req_timeout = false;

function loadVersionPage(url)
{
	if (window.XMLHttpRequest) {
		version_req = new XMLHttpRequest();
		version_req.onreadystatechange = parseVersionPage;
		version_req.overrideMimeType("text/xml");
		version_req.setRequestHeader("Cache-Control", "no-cache")
		version_req.open("GET", url, true);
		version_req.send(null);
		
		version_req_stop_timeout = false;
		version_req_timeout = false;
		setTimeout("version_req_send_timeout();",5000);
	}
}

function version_req_send_timeout()
{
	if (version_req_stop_timeout){return;}
	version_req_timeout = true;
}

function isGreaterVersion(release1, release2)
{
	// faccio uno split per il '.' e poi verifico valore per valore
	release1_numbers = release1.split('.');
	release2_numbers = release2.split('.');
	
	release1_value = 0;
	release2_value = 0;
	
	// risolvo matematicamente che  pi elegante...
	
	for (var i=0;i<release1_numbers.length;i++){
		release1_value += release1_numbers[i]*(Math.pow(10,-i*3));
	}
	
	for (var i=0;i<release2_numbers.length;i++){
		release2_value += release2_numbers[i]*(Math.pow(10,-i*3));
	}
	
	if (release1_value > release2_value) return true;
	
	return false;
	
	/* wrong
	for (i=0;i<release1_numbers.length;i++){
		try {number_exists = release2_numbers[i];} catch (ex){return true;} // se non esiste il valore nella seconda...
		if (release1_numbers[i] > release2_numbers[i]) {return true;} else if (release1_numbers[i] < release2_numbers[i]) {return false;}
	}*/
}

function parseVersionPage()
{
	if (version_req_timeout) {version_req.abort(); version_req_timeout = false; version_req_stop_timeout = true; return;}
	
	if ((version_req.readyState == 4) && (version_req.status == 200)) {
		version_req_stop_timeout = true;
		version_req_timeout = false;
		
		latest_version = version_req.responseXML.getElementsByTagName("version");
		latest_version = latest_version[0].firstChild.data;
		
		// faccio una comparazione tra versioni
		if (isGreaterVersion(latest_version,current_version)){
			there_is_a_new_version = true;
		}
		
		/*
		if (latest_version != current_version){
			there_is_a_new_version = true;
		}*/
		//debug (latest_version);
		
		if (there_is_a_new_version) {
			new_version_badge.style.display = "block"
			new_version_tooltip_string = getLocalizedString('new_version_tooltip') + " " + latest_version + " (" + getLocalizedString('you_have') + " " + current_version + ")";
			new_version_badge.setAttribute ("title", new_version_tooltip_string);
		}
	}
}

function version_check()
{
	loadVersionPage('http://www.palple.net/widgets/orarifs/version.xml');
}